package anywheresoftware.b4a.RSA.utils;

import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.RSA.utils.ExceptionType;

@ShortName("ExceptionType")

/**
 * Cipher Exception types
 * @author pmartinez
 *
 */
public enum ExceptionType implements IExceptionType{
	CIPHER_INTERNAL_ERROR("E0000","Cipher internal error"),
	NO_PUBLIC_KEY("E0001", "Public key not found: Public key needed to encrypt"), 
	NO_PRIVATE_KEY("E002", "Private key not found: Private key needed to decrypt") ;

	private final String errorCode;
	private final String errorMessage;

	private ExceptionType(String errorCode, String errorMessage) {
		this.errorCode = errorCode;
		this.errorMessage = errorMessage;
	}

	@Override
	public String getErrorCode() {
		return errorCode;
	}

	@Override
	public String getErrorMessage() {
		return errorMessage;
	}
}
