package anywheresoftware.b4a.RSA.utils;

import anywheresoftware.b4a.BA.ShortName;

@ShortName("JLibraryException")
/**
 * Exception class for the encryption/decryption process
 * @author pmartinez
 *
 */
public class JLibraryException extends Exception {
	private static final long serialVersionUID = 1L;

	private IExceptionType type = null;
	private String message;

	public JLibraryException() {
		super();
		this.type = ExceptionType.CIPHER_INTERNAL_ERROR;
		this.message = type.getErrorMessage();
	}

	public JLibraryException(Exception ex) {
		super(ex);
		this.type = ExceptionType.CIPHER_INTERNAL_ERROR;
		this.message = type.getErrorMessage();
	}

	public JLibraryException(IExceptionType type) {
		super();
		this.type = type;
		this.message = type.getErrorMessage();
	}

	public JLibraryException(IExceptionType type, String... params) {
		super();
		this.type = type;
		this.message = type.getErrorMessage();

		for (int i = params.length - 1; i >= 0; i--)
			this.message = this.message.replace("$" + (i + 1), params[i]);
	}

	@Override
	public String getMessage() {
		return message;
	}

	public String getCode() {
		return type.getErrorCode();
	}

	public void setMessage(String message) {
		this.message = message;
	}
}
